c
c prepares cubes and coordinates for readbox.f
c
c
      program mdbox
      implicit double precision(a-h,o-z)
      dimension x(10000)
      dimension y(10000)
      dimension z(10000)
      dimension q(10000)
      dimension r01(3),r02(3)
      dimension r0_1(3),r0_2(3)
      dimension r1_1(3),r2_1(3),r3_1(3)
      dimension r1_2(3),r2_2(3),r3_2(3)
      dimension a1(3),b1(3),c1(3)
      dimension a2(3),b2(3),c2(3)
      character atom(10000)*2

      ang = 0.529177d0

      open(1,file='1.cube',status='old')
      open(2,file='2.cube',status='old')
      open(3,file='mdbox.in',status='old')
      open(4,file='mdbox.out',status='unknown')

c read basic input
      read(3,*)m1,m2
      read(3,*)n1,n2
      read(3,*)i1,j1
      read(3,*)i2,j2
c n1 first atom of fragment 1
c n2 first atom of fragment 2
      m = m2 - m1 + 1

c read Gaussian cubes
c first fragment
      read(1,*)
      read(1,*)
      read(1,*)nat1,r01(1),r01(2),r01(3),k
      nat1 = -nat1
        if(n2.le.(n1+nat1-1))then
        write(4,*)'n2.le.(n1+nat1-1)',n2,n1+nat1-1
        stop
        endif
      read(1,*)na1,a1(1),a1(2),a1(3)
      read(1,*)nb1,b1(1),b1(2),b1(3)
      read(1,*)nc1,c1(1),c1(2),c1(3)
      do i = 1, nat1
      read(1,*)q(i),qq,x(i),y(i),z(i)
      enddo
      call bfaxes(nat1,i1,j1,q,x,y,z,r1_1,r2_1,r3_1,rx1,ry1,rz1)

      write(4,*)'fragment 1 COC in SF',' first atom: ',n1
      write(4,'(3f12.7)')rx1,ry1,rz1
c
c     get cube origin and cell in BF
c
      r0_1(1) = dot(r01,r1_1)
      r0_1(2) = dot(r01,r2_1)
      r0_1(3) = dot(r01,r3_1)

      write(4,*)
      write(4,*)'cube origin 1 in SF'
      write(4,'(3f12.7)')r01(1),r01(2),r01(3)
      write(4,*)
      write(4,*)'cube origin 1 in BF'
      write(4,'(3f12.7)')r0_1(1),r0_1(2),r0_1(3)

      a_1 = dot(a1,r1_1)
      a_2 = dot(a1,r2_1)
      a_3 = dot(a1,r3_1)
      a1(1) = a_1
      a1(2) = a_2
      a1(3) = a_3

      b_1 = dot(b1,r1_1)
      b_2 = dot(b1,r2_1)
      b_3 = dot(b1,r3_1)
      b1(1) = b_1
      b1(2) = b_2
      b1(3) = b_3

      c_1 = dot(c1,r1_1)
      c_2 = dot(c1,r2_1)
      c_3 = dot(c1,r3_1)
      c1(1) = c_1
      c1(2) = c_2
      c1(3) = c_3

      write(4,*)
      write(4,*)'cube cells in BF'
      write(4,*)
      write(4,*)'        1  2  3'
      write(4,*)'a-axis'
      write(4,'(3f12.7)')a1(1),a1(2),a1(3)
      write(4,*)'b-axis'
      write(4,'(3f12.7)')b1(1),b1(2),b1(3)
      write(4,*)'c-axis'
      write(4,'(3f12.7)')c1(1),c1(2),c1(3)

c second fragment
      read(2,*)
      read(2,*)
      read(2,*)nat2,r02(1),r02(2),r02(3),k
      nat2 = -nat2
      read(2,*)na2,a2(1),a2(2),a2(3)
      read(2,*)nb2,b2(1),b2(2),b2(3)
      read(2,*)nc2,c2(1),c2(2),c2(3)
      do i = 1, nat2
      read(2,*)q(i),qq,x(i),y(i),z(i)
      enddo
      call bfaxes(nat2,i2,j2,q,x,y,z,r1_2,r2_2,r3_2,rx2,ry2,rz2)

      write(4,*)
      write(4,*)'fragment 2 COC in SF',' first atom: ',n2
      write(4,'(3f12.7)')rx2,ry2,rz2
c
c     get cube origin and cell in BF
c
      r0_2(1) = dot(r02,r1_2)
      r0_2(2) = dot(r02,r2_2)
      r0_2(3) = dot(r02,r3_2)

      write(4,*)
      write(4,*)'cube origin 2 in SF'
      write(4,'(3f12.7)')r02(1),r02(2),r02(3)
      write(4,*)
      write(4,*)'cube origin 2 in BF'
      write(4,'(3f12.7)')r0_2(1),r0_2(2),r0_2(3)

      a_1 = dot(a2,r1_2)
      a_2 = dot(a2,r2_2)
      a_3 = dot(a2,r3_2)
      a2(1) = a_1
      a2(2) = a_2
      a2(3) = a_3

      b_1 = dot(b2,r1_2)
      b_2 = dot(b2,r2_2)
      b_3 = dot(b2,r3_2)
      b2(1) = b_1
      b2(2) = b_2
      b2(3) = b_3

      c_1 = dot(c2,r1_2)
      c_2 = dot(c2,r2_2)
      c_3 = dot(c2,r3_2)
      c2(1) = c_1
      c2(2) = c_2
      c2(3) = c_3

      write(4,*)
      write(4,*)'cube cells in BF'
      write(4,*)
      write(4,*)'        1  2  3'
      write(4,*)'a-axis'
      write(4,'(3f12.7)')a2(1),a2(2),a2(3)
      write(4,*)'b-axis'
      write(4,'(3f12.7)')b2(1),b2(2),b2(3)
      write(4,*)'c-axis'
      write(4,'(3f12.7)')c2(1),c2(2),c2(3)

c
c scan over MD frames: read from fort.9
c
      write(4,*)'---------- main output below ----------'
      write(4,*)m

      do j = 1, m1 - 1
      read(9,*)nat_tot
      do i = 1, nat_tot
      read(9,*)
      enddo
      enddo

      do j = m1, m2

c first fragment
      read(9,*)nat_tot
        if(nat_tot.lt.(n2+nat2-1))then
        write(4,*)'nat_tot.lt.(n2+nat2-1)',nat_tot,n2+nat2-1
        stop
        endif
c skip to line n1 (1st line of 1st fragment)
      do i = 1, n1 - 1
      read(9,*)
      enddo
      do i=1,nat1
      read(9,*)k,atom(i),x(i),y(i),z(i),k
      x(i) = x(i) / ang
      y(i) = y(i) / ang
      z(i) = z(i) / ang
      q(i) = znuc(atom(i))
      enddo
      call bfaxes(nat1,i1,j1,q,x,y,z,r1_1,r2_1,r3_1,rx1,ry1,rz1)

c cube origin in SF
      tmp_x = r0_1(1) * r1_1(1) + r0_1(2) * r2_1(1) + r0_1(3) * r3_1(1)
      tmp_y = r0_1(1) * r1_1(2) + r0_1(2) * r2_1(2) + r0_1(3) * r3_1(2)
      tmp_z = r0_1(1) * r1_1(3) + r0_1(2) * r2_1(3) + r0_1(3) * r3_1(3)
      tmp_x = tmp_x + rx1
      tmp_y = tmp_y + ry1
      tmp_z = tmp_z + rz1
      write(4,'(i6,3f12.7)')j,tmp_x,tmp_y,tmp_z

c axes in SF
c  a
      tmp_x = a1(1) * r1_1(1) + a1(2) * r2_1(1) + a1(3) * r3_1(1)
      tmp_y = a1(1) * r1_1(2) + a1(2) * r2_1(2) + a1(3) * r3_1(2)
      tmp_z = a1(1) * r1_1(3) + a1(2) * r2_1(3) + a1(3) * r3_1(3)
      write(4,'(i6,3f12.7)')na1,tmp_x,tmp_y,tmp_z
c  b
      tmp_x = b1(1) * r1_1(1) + b1(2) * r2_1(1) + b1(3) * r3_1(1)
      tmp_y = b1(1) * r1_1(2) + b1(2) * r2_1(2) + b1(3) * r3_1(2)
      tmp_z = b1(1) * r1_1(3) + b1(2) * r2_1(3) + b1(3) * r3_1(3)
      write(4,'(i6,3f12.7)')nb1,tmp_x,tmp_y,tmp_z
c  c
      tmp_x = c1(1) * r1_1(1) + c1(2) * r2_1(1) + c1(3) * r3_1(1)
      tmp_y = c1(1) * r1_1(2) + c1(2) * r2_1(2) + c1(3) * r3_1(2)
      tmp_z = c1(1) * r1_1(3) + c1(2) * r2_1(3) + c1(3) * r3_1(3)
      write(4,'(i6,3f12.7)')nc1,tmp_x,tmp_y,tmp_z

c     write(4,*)'frame ',j,' SF'
c     write(4,'(6f12.7)')rx1,ry1,rz1,tmp_x,tmp_y,tmp_z
c     write(4,'(3f12.7)')r1_1(1),r1_1(2),r1_1(3)
c     write(4,'(3f12.7)')r2_1(1),r2_1(2),r2_1(3)
c     write(4,'(3f12.7)')r3_1(1),r3_1(2),r3_1(3)

c second fragment
c skip to line n2 (1st line of 2nd fragment)
      do i = n1 + nat1, n2 - 1
      read(9,*)
      enddo
      do i=1,nat2
      read(9,*)k,atom(i),x(i),y(i),z(i),k
      x(i) = x(i) / ang
      y(i) = y(i) / ang
      z(i) = z(i) / ang
      q(i) = znuc(atom(i))
      enddo
      call bfaxes(nat2,i2,j2,q,x,y,z,r1_2,r2_2,r3_2,rx2,ry2,rz2)

c skip to end of this frame
      do i = n2 + nat2, nat_tot
      read(9,*)
      enddo

c cube origin in SF
      tmp_x = r0_2(1) * r1_2(1) + r0_2(2) * r2_2(1) + r0_2(3) * r3_2(1)
      tmp_y = r0_2(1) * r1_2(2) + r0_2(2) * r2_2(2) + r0_2(3) * r3_2(2)
      tmp_z = r0_2(1) * r1_2(3) + r0_2(2) * r2_2(3) + r0_2(3) * r3_2(3)
      tmp_x = tmp_x + rx2
      tmp_y = tmp_y + ry2
      tmp_z = tmp_z + rz2
      write(4,'(i6,3f12.7)')j,tmp_x,tmp_y,tmp_z

c axes in SF
c  a
      tmp_x = a2(1) * r1_2(1) + a2(2) * r2_2(1) + a2(3) * r3_2(1)
      tmp_y = a2(1) * r1_2(2) + a2(2) * r2_2(2) + a2(3) * r3_2(2)
      tmp_z = a2(1) * r1_2(3) + a2(2) * r2_2(3) + a2(3) * r3_2(3)
      write(4,'(i6,3f12.7)')na2,tmp_x,tmp_y,tmp_z
c  b
      tmp_x = b2(1) * r1_2(1) + b2(2) * r2_2(1) + b2(3) * r3_2(1)
      tmp_y = b2(1) * r1_2(2) + b2(2) * r2_2(2) + b2(3) * r3_2(2)
      tmp_z = b2(1) * r1_2(3) + b2(2) * r2_2(3) + b2(3) * r3_2(3)
      write(4,'(i6,3f12.7)')nb2,tmp_x,tmp_y,tmp_z
c  c
      tmp_x = c2(1) * r1_2(1) + c2(2) * r2_2(1) + c2(3) * r3_2(1)
      tmp_y = c2(1) * r1_2(2) + c2(2) * r2_2(2) + c2(3) * r3_2(2)
      tmp_z = c2(1) * r1_2(3) + c2(2) * r2_2(3) + c2(3) * r3_2(3)
      write(4,'(i6,3f12.7)')nc2,tmp_x,tmp_y,tmp_z

      xx = rx2 - rx1
      yy = ry2 - ry1
      zz = rz2 - rz1
      rr = dsqrt(xx*xx + yy*yy + zz*zz)
      write(23,*)j,rr

c     write(4,'(3f12.7)')
c     write(4,'(6f12.7)')rx2,ry2,rz2,tmp_x,tmp_y,tmp_z
c     write(4,'(3f12.7)')r1_2(1),r1_2(2),r1_2(3)
c     write(4,'(3f12.7)')r2_2(1),r2_2(2),r2_2(3)
c     write(4,'(3f12.7)')r3_2(1),r3_2(2),r3_2(3)

      enddo

      stop
      end
c
      double precision function znuc(a)
      character a*2

      znuc = 0.d0
      if(a.eq.'H'.or.a.eq.'h')   znuc =  1.d0
      if(a.eq.'He'.or.a.eq.'he') znuc =  2.d0
      if(a.eq.'Li'.or.a.eq.'li') znuc =  3.d0
      if(a.eq.'Be'.or.a.eq.'be') znuc =  4.d0
      if(a.eq.'B'.or.a.eq.'b')   znuc =  5.d0
      if(a.eq.'C'.or.a.eq.'c')   znuc =  6.d0
      if(a.eq.'N'.or.a.eq.'n')   znuc =  7.d0
      if(a.eq.'O'.or.a.eq.'o')   znuc =  8.d0
      if(a.eq.'F'.or.a.eq.'f')   znuc =  9.d0
      if(a.eq.'Ne'.or.a.eq.'ne') znuc = 10.d0
      if(a.eq.'Na'.or.a.eq.'na') znuc = 11.d0
      if(a.eq.'Mg'.or.a.eq.'mg') znuc = 12.d0
      if(a.eq.'Al'.or.a.eq.'al') znuc = 13.d0
      if(a.eq.'Si'.or.a.eq.'si') znuc = 14.d0
      if(a.eq.'P'.or.a.eq.'p')   znuc = 15.d0
      if(a.eq.'S'.or.a.eq.'s')   znuc = 16.d0
      if(a.eq.'Cl'.or.a.eq.'cl') znuc = 17.d0
      if(a.eq.'Ar'.or.a.eq.'ar') znuc = 18.d0
      if(a.eq.'Se'.or.a.eq.'se') znuc = 34.d0
      if(a.eq.'Ru'.or.a.eq.'ru') znuc = 44.d0
      if(a.eq.'Cd'.or.a.eq.'cd') znuc = 48.d0
      if(a.eq.'W'.or.a.eq.'w')   znuc = 74.d0

      return
      end
