c
c takes input from mdbox.f  and computes overlaps
c
c
      program readbox
      implicit double precision(a-h,o-z)
      dimension f1(200,200,200)
      dimension f2(200,200,200)
      dimension a1(3),a2(3)
      dimension b1(3),b2(3)
      dimension c1(3),c2(3)
      character title1*72,title2*72
c
      open(1,file='1.cube',status='old')
      open(2,file='2.cube',status='old')
      open(3,file='mdbox.out',status='old')

c cube 1
      read(1,'(a72)')title1
      read(1,*)
      read(1,*)nat1
      read(1,*)na1
      read(1,*)nb1
      read(1,*)nc1
      nat1 = -nat1
      do i = 1, nat1
      read(1,*)
      enddo
      read(1,*)

      do i = 1, na1
      do j = 1, nb1
       read(1,'(6e13.5)')( f1(k,j,i),k=1,nc1)
      enddo
      enddo

c cube 2
      read(2,'(a72)')title2
      read(2,*)
      read(2,*)nat2
      read(2,*)na2
      read(2,*)nb2
      read(2,*)nc2
      nat2 = -nat2
      do i = 1, nat2
      read(2,*)
      enddo
      read(2,*)

      do i = 1, na2
      do j = 1, nb2
       read(2,'(6e13.5)')( f2(k,j,i),k=1,nc2)
      enddo
      enddo

      write(*,'(a29,a20,a3,a20,a1)')
     &'# MD-frame  CUBE-1@CUBE-2  < ',title1,' | ',title2,'>'
c average of overlap squared
      s2 = 0.d0

c read header
      do i = 1, 38
      read(3,*)
      enddo
c scan over md frames
      read(3,*)m
      do iframe = 1, m
      icount = 0

c box 1
      read(3,*)ii,x01,y01,z01
      read(3,*)na1,a1(1),a1(2),a1(3)
      read(3,*)nb1,b1(1),b1(2),b1(3)
      read(3,*)nc1,c1(1),c1(2),c1(3)
      cell_a1 = dsqrt(a1(1) * a1(1) + a1(2) * a1(2) + a1(3) * a1(3))
      cell_b1 = dsqrt(b1(1) * b1(1) + b1(2) * b1(2) + b1(3) * b1(3))
      cell_c1 = dsqrt(c1(1) * c1(1) + c1(2) * c1(2) + c1(3) * c1(3))
      vol1 = cell_a1 * cell_b1 * cell_c1

c box 2
      read(3,*)ii,x02,y02,z02
      read(3,*)na2,a2(1),a2(2),a2(3)
      read(3,*)nb2,b2(1),b2(2),b2(3)
      read(3,*)nc2,c2(1),c2(2),c2(3)

      cell_a2 = dsqrt(a2(1) * a2(1) + a2(2) * a2(2) + a2(3) * a2(3))
      sa2 = dfloat(na2 - 1) * cell_a2

      cell_b2 = dsqrt(b2(1) * b2(1) + b2(2) * b2(2) + b2(3) * b2(3))
      sb2 = dfloat(nb2 - 1) * cell_b2

      cell_c2 = dsqrt(c2(1) * c2(1) + c2(2) * c2(2) + c2(3) * c2(3))
      sc2 = dfloat(nc2 - 1) * cell_c2

      vol2 = cell_a2 * cell_b2 * cell_c2

c overlap integral
         s = 0.d0

         do i = 1, na1
              ri = dfloat(i - 1)
         do j = 1, nb1
              rj = dfloat(j - 1)
         do k = 1, nc1
              rk = dfloat(k - 1)
         x = x01 + ri * a1(1) + rj * b1(1) + rk * c1(1)
         y = y01 + ri * a1(2) + rj * b1(2) + rk * c1(2)
         z = z01 + ri * a1(3) + rj * b1(3) + rk * c1(3)

         xx = x - x02
         yy = y - y02
         zz = z - z02

c see if this grid point of cube 1 falls inside cube 2
         dot_a2 = xx * a2(1) + yy * a2(2) + zz * a2(3)
         dot_b2 = xx * b2(1) + yy * b2(2) + zz * b2(3)
         dot_c2 = xx * c2(1) + yy * c2(2) + zz * c2(3)
         if(dot_a2.gt.0.d0.and.dot_b2.gt.0.d0.and.dot_c2.gt.0.d0)then
         dot_a2 = dot_a2 / cell_a2
         dot_b2 = dot_b2 / cell_b2
         dot_c2 = dot_c2 / cell_c2
         if(dot_a2.lt.sa2.and.dot_b2.lt.sb2.and.dot_c2.lt.sc2)then

         icount = icount + 1

c coordinate in cube 2
         la2 = int( dot_a2 / cell_a2 ) + 1
         lb2 = int( dot_b2 / cell_b2 ) + 1
         lc2 = int( dot_c2 / cell_c2 ) + 1

         da1 = dot_a2 - dfloat(la2 - 1) * cell_a2
         da2 = da1 - cell_a2

         db1 = dot_b2 - dfloat(lb2 - 1) * cell_b2
         db2 = db1 - cell_b2

         dc1 = dot_c2 - dfloat(lc2 - 1) * cell_c2
         dc2 = dc1 - cell_c2

c Lagrange interpolant: IMPORTANT!! function read in a (1:c,2:b,3:a) order
         f111 = f2( lc2   ,   lb2   ,   la2     )
         f112 = f2( lc2   ,   lb2   ,   la2 + 1 )
         f121 = f2( lc2   ,   lb2 + 1 , la2     )
         f211 = f2( lc2 + 1 , lb2   ,   la2     )
         f122 = f2( lc2   ,   lb2 + 1 , la2 + 1 )
         f212 = f2( lc2 + 1 , lb2   ,   la2 + 1 )
         f221 = f2( lc2 + 1 , lb2 + 1 , la2     )
         f222 = f2( lc2 + 1 , lb2 + 1 , la2 + 1 )

c
c 3D Lagrange polynomial in cell
c
         f = - ( f111 * da2 * db2 * dc2 
     &          -f112 * da1 * db2 * dc2 
     &          -f121 * da2 * db1 * dc2 
     &          -f211 * da2 * db2 * dc1 
     &           f122 * da1 * db1 * dc2 
     &           f212 * da1 * db2 * dc1 
     &           f221 * da2 * db1 * dc1 
     &          -f222 * da1 * db1 * dc1 ) / vol2

         s = s + f1(k,j,i) * f

         endif
         endif

         enddo
         enddo
         enddo

      s = s * vol1
      s2 = s2 + s * s
      write(*,'(i9,6x,i9,12x,d16.9)')iframe,icount,s

      enddo

      s2 = s2 / dfloat(m)

      write(*,'(a1)')'#'
      write(*,'(a22,d16.9)')'# < |< A | B >|^2 > = ',s2
      write(*,'(a1)')'#'

      stop
      end
